#ifndef CLIB_ASYNCIO_PROTOS_H
#define CLIB_ASYNCIO_PROTOS_H
#ifndef LIBRARIES_ASYNCIO_H
#include <libraries/asyncio.h>
#endif

/* Functions for asycioppc V40 */

/* These are the functions for the M68K side of your program !! */

#ifndef __PPC__

#ifdef __cplusplus
extern "C" {
#endif

struct AsyncFile *OpenAsync(STRPTR fileName,ULONG mode,LONG bufferSize);
struct AsyncFile *OpenAsyncFromFH(BPTR handle,ULONG mode,LONG bufferSize);
LONG CloseAsync(struct AsyncFile *file);
LONG ReadAsync(struct AsyncFile *file,APTR buffer,LONG numBytes);
LONG ReadCharAsync(struct AsyncFile *file);
LONG ReadLineAsync(struct AsyncFile *file,STRPTR buffer,LONG size);
LONG WriteAsync(struct AsyncFile *file,APTR buffer,LONG numBytes);
LONG WriteCharAsync(struct AsyncFile *file,ULONG ch);
LONG WriteLineAsync(struct AsyncFile *file,STRPTR line);
LONG SeekAsync(struct AsyncFile *file,LONG position,LONG mode);
STRPTR FGetsAsync(struct AsyncFile *file,STRPTR buffer,LONG size);
STRPTR FGetsLenAsync(struct AsyncFile *file,STRPTR buffer,LONG size,LONG *length);
LONG PeekAsync(struct AsyncFile *file,APTR buffer,LONG numBytes);

#ifdef __cplusplus
}
#endif

#else

/* V40 functions */

/* These are the functions for the PPC-WOS side of your program !! */

struct AsyncFile *OpenAsyncPPC(STRPTR fileName,ULONG mode,LONG bufferSize);
struct AsyncFile *OpenAsyncFromFHPPC(BPTR handle,ULONG mode,LONG bufferSize);
LONG CloseAsyncPPC(struct AsyncFile *file);
LONG ReadAsyncPPC(struct AsyncFile *file,APTR buffer,LONG numBytes);
LONG ReadCharAsyncPPC(struct AsyncFile *file);
LONG ReadLineAsyncPPC(struct AsyncFile *file,STRPTR buffer,LONG size);
LONG WriteAsyncPPC(struct AsyncFile *file,APTR buffer,LONG numBytes);
LONG WriteCharAsyncPPC(struct AsyncFile *file,ULONG ch);
LONG WriteLineAsyncPPC(struct AsyncFile *file,STRPTR line);
LONG SeekAsyncPPC(struct AsyncFile *file,LONG position,LONG mode);
STRPTR FGetsAsyncPPC(struct AsyncFile *file,STRPTR buffer,LONG size);
STRPTR FGetsLenAsyncPPC(struct AsyncFile *file,STRPTR buffer,LONG size,LONG *length);
LONG PeekAsyncPPC(struct AsyncFile *file,APTR buffer,LONG numBytes);

#endif

#endif
